#ifndef _X86
#define _X86

unsigned int *hd_buf;
volatile unsigned long timer;

 

typedef struct 
  {
    unsigned short configuration_id;
    unsigned short no_of_fixed_cylinders;
    unsigned short no_of_removable_cylinders;
    unsigned short no_of_heads;
    unsigned short no_of_unformatted_bytes_per_physical_track;
    unsigned short no_of_unformatted_bytes_per_sector;
    unsigned short no_of_physical_sectors_per_track;
    unsigned short no_of_bytes_in_the_intersector_gaps;
    unsigned short no_of_bytes_in_the_sync_fields;
    unsigned short zero;
    unsigned char serial_number[20];
    unsigned short controller_type;
    unsigned short controller_buffer_size;
    unsigned short no_of_ECC_bytes_on_long_commands;
    unsigned char firmware_revision[8];
    unsigned char model_number[40];
    unsigned short no_of_sectors_interrupt;
    unsigned short double_word_transfer_flag;
    unsigned short write_protected;
    unsigned char reserved[411];
    
      
  }  ident_drive_struct;


#define ata_data_register 	0x1f0
#define ata_error_register	0x1f1
#define ata_sector_count	0x1f2
#define ata_sector_number	0x1f3
#define ata_cylinder_low	0x1f4
#define ata_cylinder_high	0x1f5
#define ata_SDH_register	0x1f6
#define ata_cmd_stat_register   0x1f7

#define ata_alternate_address	0x3f6
#define ata_drive_address	0x3f7



#define ata_busy_flag  128
#define ata_drive_ready_flag  64
#define ata_data_ready_flag  8


#define  ata_device_and_head_register  0x1f6
#define  ata_command_identify_drive  0xec


#define ata_reserved 				1
#define hard_sectored 				2
#define soft_sectored 				4
#define not_mfm_encoded 			8
#define head_switching_time_above_15us 		16
#define spindle_motor_can_be_switched_off 	32
#define non_removable_disk 			64
#define removable_disk 				128
#define dtr_lower_5mbsec 			256
#define dtr_lower_10_higher_5mbsec	 	512
#define dtr_higher_10mbsec 			1024
#define rotational_frequency_tolerance_above_05 2048
#define data_strobe_offset_option_avaliable 	4096
#define track_offset_option_avaliable 		8192
#define format_speed_tolerance_gap_required 	16384
#define non_magnetic_drive			32768


/* inline void hd(void);
*/

// long ata_sec_buf[128];
unsigned short ata_sec_offset;

void	add2sec ( unsigned *add, long count);

inline void ata_wait(void);
inline void ata_drive_ready(void);
inline void ata_data_ready(void);

inline void ata_command (unsigned char command);

inline void ata_hd_init(int cyl, int head, int sec);
inline void ata_write_buf (unsigned int* buffer, long count);
inline void ata_read_buf (unsigned int* buffer, long count);

inline void ata_write_sec (int cyl, int head, int sec, void* buffer, long count );
inline void ata_read_sec (int cyl, int head, int sec, void* buffer, long count);


inline void ata_select (unsigned char device); /*valjer aktiv ata-enhet */
unsigned char ata_recalibrate (unsigned short disc_address);

void identify_drive (void);           /* jag gor det i maskinkod*/

ident_drive_struct*	ata_get_info(unsigned char disc_no);

inline void ata_identify_drive ( unsigned char disc_no );

 
//unsigned short BCD_to_ASCII (unsigned char OCD);
enum critics {RTC_sec,RTC_sec_alarm};

typedef struct {
    unsigned char RTC_sec;
    unsigned char RTC_sec_alarm;
    unsigned char RTC_minutes;
    unsigned char RTC_minutes_alarm;
    unsigned char RTC_hours;
    unsigned char RTC_hours_alarm;
    unsigned char RTC_day_of_week;
    unsigned char RTC_date_day;
    
    unsigned char RTC_date_month;
    unsigned char RTC_date_year;
    unsigned char status_register_a;
    
    unsigned char status_register_b;
    
    unsigned char status_register_c;
    unsigned char status_register_d;
    
    unsigned char diagnostic_status;
    unsigned char shutdown_status;

    unsigned char floppy_disk_drive_types;

    unsigned char system_configuration_settings;

    unsigned char hard_disk_types;
    unsigned char typematic_parameters;
    
    unsigned char installed_equipment;
    
    unsigned char base_memory_LOB; /*low order byte */
    unsigned char base_memory_HOB;  /* high order byte */
    unsigned char extended_memory_LOB;
    unsigned char extended_memory_HOB;
    
    unsigned char harddisk_0_extended_type;
    unsigned char harddisk_1_extended_type;
    
    unsigned char user_c_CLSB;/*cylinders least significant byte */
    unsigned char user_c_CMSB;
    unsigned char user_c_NOH; /*numbers of head */
    unsigned char user_c_WPCLSB; /*write precomp cylinder last bite ? */
    unsigned char user_c_WPCMSB;
    unsigned char user_c_control_byte;
    unsigned char user_c_LZLSB;
    unsigned char user_c_LZMSB;
    unsigned char user_c_NOS; /*number of sectors */
    
    unsigned char user_d_CLSB;/*cylinders least significant byte */
    unsigned char user_d_CMSB;
    unsigned char user_d_NOH; /*numbers of head */
    unsigned char user_d_WPCLSB; /*write precomp cylinder last bite ? */
    unsigned char user_d_WPCMSB;
    unsigned char user_d_control_byte;
    unsigned char user_d_LZLSB;
    unsigned char user_d_LZMSB;
    unsigned char user_d_NOS; /*number of sectors */
    
    unsigned char system_operational_flags;
    
    unsigned char CMOS_checksum_HOB; /*high order byte */
    unsigned char CMOS_checksum_LOB;
     
    unsigned char actual_extended_memory_LOB;
    unsigned char actual_extended_memory_HOB;
    
    unsigned char century_date;
    
    unsigned char post_information_flags;
    
    unsigned char BIOS_and_shadow_option_flags[1];
    
    unsigned char chipset_specific_information;
    unsigned char password_seed_and_color_option;
    unsigned char encrypted_password;
    
    unsigned char extended_CMOS_checksum_MSB;
    unsigned char extended_CMOS_checksum_LSB;
    
    unsigned char model_number_byte;
    
    unsigned char serial_number[5];
    
    unsigned char CRC_byte;
    unsigned char century_byte;
    
    unsigned char date_alarm;
    unsigned char extended_control_register4a;
    unsigned char extended_control_register4b;
    
    unsigned char reserved[1];
    
    
    unsigned char RTC_address_2;
    unsigned char RTC_address_3;
    
    unsigned extended_RAM_address_LSB;
    unsigned extended_RAM_address_MSB;
    
    unsigned char reserved_;
    unsigned char extended_RAM_data_port;
    
    unsigned char reserved__[10]; 
    }	CMOS;

CMOS CMOS_data;




    typedef char byte;

typedef unsigned short word;
typedef unsigned long dword;


 static const byte hor_regs [] = { 0x0,  0x1,  0x2,  0x3,  0x4, 0x5,  0x13 };

static const byte width_256[] = { 0x5f, 0x3f, 0x40, 0x82, 0x4a, 0x9a, 0x20 };
static const byte width_320[] = { 0x5f, 0x4f, 0x50, 0x82, 0x54, 0x80, 0x28 };
static const byte width_360[] = { 0x6b, 0x59, 0x5a, 0x8e, 0x5e, 0x8a, 0x2d };
static const byte width_376[] = { 0x6e, 0x5d, 0x5e, 0x91, 0x62, 0x8f, 0x2f };
static const byte width_400[] = { 0x70, 0x63, 0x64, 0x92, 0x65, 0x82, 0x32 };
// static const byte width_400[] = { 0x5f, 0x4f, 0x50, 0x82, 0x54, 0x80, 0x50 };


static const byte ver_regs[] = { 0x6,  0x7,  0x9,  0x10, 0x11, 0x12, 0x15, 0x16 };

static const byte height_200[] = { 0xbf, 0x1f, 0x41, 0x9c, 0x8e, 0x8f, 0x96, 0xb9 };
static const byte height_224[] = { 0x0b, 0x3e, 0x41, 0xda, 0x9c, 0xbf, 0xc7, 0x04 };
static const byte height_240[] = { 0x0d, 0x3e, 0x41, 0xea, 0xac, 0xdf, 0xe7, 0x06 };
static const byte height_256[] = { 0x23, 0xb2, 0x61, 0x0a, 0xac, 0xff, 0x07, 0x1a };
static const byte height_270[] = { 0x30, 0xf0, 0x61, 0x20, 0xa9, 0x1b, 0x1f, 0x2f };
static const byte height_300[] = { 0x70, 0xf0, 0x61, 0x5b, 0x8c, 0x57, 0x58, 0x70 };
static const byte height_360[] = { 0xbf, 0x1f, 0x40, 0x88, 0x85, 0x67, 0x6d, 0xba };
static const byte height_400[] = { 0xbf, 0x1f, 0x40, 0x9c, 0x8e, 0x8f, 0x96, 0xb9 };
static const byte height_480[] = { 0x0d, 0x3e, 0x40, 0xea, 0xac, 0xdf, 0xe7, 0x06 };
static const byte height_564[] = { 0x62, 0xf0, 0x60, 0x37, 0x89, 0x33, 0x3c, 0x5c };
static const byte height_600[] = { 0x70, 0xf0, 0x60, 0x5b, 0x8c, 0x57, 0x58, 0x70 };



int init_graph (int width, int height, int chain4);
void enable_chain4(void);

void store_CMOS(void);


unsigned inportb(unsigned short port);
void insw(unsigned short port, unsigned short *dest, unsigned long count);
unsigned inportl(unsigned port);
void outportb(unsigned port, unsigned val);
void outportw(unsigned port, unsigned val);
void outportl(unsigned port, unsigned val);



void init_8259(void);
void enable(void);			// Enables interrupt, for instance when someone presses a key.
void disable(void);			// other way round..

#endif
